c     Copyright (C)
c     2008-2013 Universit Paul Sabatier
c     2008-2013 Centre National de la Recherche Scientifique
c     2008-2013 Ecole des Mines d'Albi
c     2008-2013 Universit de Bordeaux 1
c     2008-2013 Fondation STAE
c     2014-2018 Meso-Star
c     
c     KDISTRIBUTION is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     KDISTRIBUTION is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with KDISTRIBUTION; if not, see <http://www.gnu.org/licenses/>
c
      subroutine linear_interpolation(x1,x2,f1,f2,x0,f0)
      implicit none
      include 'max.inc'
c
c     Purpose: to perform a linear interpolation between two reference values
c
c     Inputs:
c       + x1, x2: values of x for the two reference points
c       + f1, f2: f1=f(x1) and f2=f(x2), known values of f at points x1 and x2
c       + x0: value of x where interpolation has to be performed
c     
c     Output:
c       + f0: value of f interpolated at x=x0
c

c     I/O
      double precision x1,x2
      double precision f1,f2
      double precision x0,f0
c     temp
c     labem
      integer strlen
      character*(Nchar_mx) label
      label='subroutine linear_interpolation'

      if (x1.eq.x2) then
         write(*,*) 'Error from ',label(1:strlen(label)),' :'
         write(*,*) 'x1=',x1
         write(*,*) 'x2=',x2
         write(*,*) 'have identical values'
         stop
      else
         f0=f1+(f2-f1)/(x2-x1)*(x0-x1)
      endif

      return
      end
